diff --git a/lib/librte_eal/arm/include/rte_atomic_32.h b/lib/librte_eal/arm/include/rte_atomic_32.h
index fe48ab428e..c00ab78dba 100644
--- a/lib/librte_eal/arm/include/rte_atomic_32.h
+++ b/lib/librte_eal/arm/include/rte_atomic_32.h
@@ -6,7 +6,7 @@
 #define _RTE_ATOMIC_ARM32_H_
 
 #ifndef RTE_FORCE_INTRINSICS
-#  error Platform must be built with CONFIG_RTE_FORCE_INTRINSICS
+#  error Platform must be built with RTE_FORCE_INTRINSICS
 #endif
 
 #ifdef __cplusplus
diff --git a/lib/librte_eal/arm/include/rte_atomic_64.h b/lib/librte_eal/arm/include/rte_atomic_64.h
index 20dd6c75dd..2cef88629c 100644
--- a/lib/librte_eal/arm/include/rte_atomic_64.h
+++ b/lib/librte_eal/arm/include/rte_atomic_64.h
@@ -7,7 +7,7 @@
 #define _RTE_ATOMIC_ARM64_H_
 
 #ifndef RTE_FORCE_INTRINSICS
-#  error Platform must be built with CONFIG_RTE_FORCE_INTRINSICS
+#  error Platform must be built with RTE_FORCE_INTRINSICS
 #endif
 
 #ifdef __cplusplus
diff --git a/lib/librte_eal/arm/include/rte_byteorder.h b/lib/librte_eal/arm/include/rte_byteorder.h
index 9ec4a97508..df2f1d87ba 100644
--- a/lib/librte_eal/arm/include/rte_byteorder.h
+++ b/lib/librte_eal/arm/include/rte_byteorder.h
@@ -6,7 +6,7 @@
 #define _RTE_BYTEORDER_ARM_H_
 
 #ifndef RTE_FORCE_INTRINSICS
-#  error Platform must be built with CONFIG_RTE_FORCE_INTRINSICS
+#  error Platform must be built with RTE_FORCE_INTRINSICS
 #endif
 
 #ifdef __cplusplus
diff --git a/lib/librte_eal/arm/include/rte_mcslock.h b/lib/librte_eal/arm/include/rte_mcslock.h
index dd1fe135ba..896d678073 100644
--- a/lib/librte_eal/arm/include/rte_mcslock.h
+++ b/lib/librte_eal/arm/include/rte_mcslock.h
@@ -6,7 +6,7 @@
 #define _RTE_MCSLOCK_ARM_H_
 
 #ifndef RTE_FORCE_INTRINSICS
-#  error Platform must be built with CONFIG_RTE_FORCE_INTRINSICS
+#  error Platform must be built with RTE_FORCE_INTRINSICS
 #endif
 
 #ifdef __cplusplus
diff --git a/lib/librte_eal/arm/include/rte_spinlock.h b/lib/librte_eal/arm/include/rte_spinlock.h
index 1a6916b6e8..a973763c23 100644
--- a/lib/librte_eal/arm/include/rte_spinlock.h
+++ b/lib/librte_eal/arm/include/rte_spinlock.h
@@ -6,7 +6,7 @@
 #define _RTE_SPINLOCK_ARM_H_
 
 #ifndef RTE_FORCE_INTRINSICS
-#  error Platform must be built with CONFIG_RTE_FORCE_INTRINSICS
+#  error Platform must be built with RTE_FORCE_INTRINSICS
 #endif
 
 #ifdef __cplusplus
diff --git a/lib/librte_eal/arm/include/rte_ticketlock.h b/lib/librte_eal/arm/include/rte_ticketlock.h
index e09fbd6a65..e66beefbe2 100644
--- a/lib/librte_eal/arm/include/rte_ticketlock.h
+++ b/lib/librte_eal/arm/include/rte_ticketlock.h
@@ -6,7 +6,7 @@
 #define _RTE_TICKETLOCK_ARM_H_
 
 #ifndef RTE_FORCE_INTRINSICS
-#  error Platform must be built with CONFIG_RTE_FORCE_INTRINSICS
+#  error Platform must be built with RTE_FORCE_INTRINSICS
 #endif
 
 #ifdef __cplusplus
diff --git a/lib/librte_eal/common/eal_common_dynmem.c b/lib/librte_eal/common/eal_common_dynmem.c
index 1cefe52443..7c5437ddfa 100644
--- a/lib/librte_eal/common/eal_common_dynmem.c
+++ b/lib/librte_eal/common/eal_common_dynmem.c
@@ -120,7 +120,7 @@ eal_dynmem_memseg_lists_init(void)
 
 	if (max_seglists_per_type == 0) {
 		RTE_LOG(ERR, EAL, "Cannot accommodate all memory types, please increase %s\n",
-			RTE_STR(CONFIG_RTE_MAX_MEMSEG_LISTS));
+			RTE_STR(RTE_MAX_MEMSEG_LISTS));
 		goto out;
 	}
 
@@ -180,7 +180,7 @@ eal_dynmem_memseg_lists_init(void)
 			if (msl_idx >= RTE_MAX_MEMSEG_LISTS) {
 				RTE_LOG(ERR, EAL,
 					"No more space in memseg lists, please increase %s\n",
-					RTE_STR(CONFIG_RTE_MAX_MEMSEG_LISTS));
+					RTE_STR(RTE_MAX_MEMSEG_LISTS));
 				goto out;
 			}
 			msl = &mcfg->memsegs[msl_idx++];
diff --git a/lib/librte_eal/freebsd/eal_memory.c b/lib/librte_eal/freebsd/eal_memory.c
index 8d4b26b9b8..78ac142b82 100644
--- a/lib/librte_eal/freebsd/eal_memory.c
+++ b/lib/librte_eal/freebsd/eal_memory.c
@@ -173,8 +173,8 @@ rte_eal_hugepage_init(void)
 			}
 			if (msl_idx == RTE_MAX_MEMSEG_LISTS) {
 				RTE_LOG(ERR, EAL, "Could not find space for memseg. Please increase %s and/or %s in configuration.\n",
-					RTE_STR(CONFIG_RTE_MAX_MEMSEG_PER_TYPE),
-					RTE_STR(CONFIG_RTE_MAX_MEM_MB_PER_TYPE));
+					RTE_STR(RTE_MAX_MEMSEG_PER_TYPE),
+					RTE_STR(RTE_MAX_MEM_MB_PER_TYPE));
 				return -1;
 			}
 			arr = &msl->memseg_arr;
@@ -405,7 +405,7 @@ memseg_primary_init(void)
 			if (msl_idx >= RTE_MAX_MEMSEG_LISTS) {
 				RTE_LOG(ERR, EAL,
 					"No more space in memseg lists, please increase %s\n",
-					RTE_STR(CONFIG_RTE_MAX_MEMSEG_LISTS));
+					RTE_STR(RTE_MAX_MEMSEG_LISTS));
 				return -1;
 			}
 
diff --git a/lib/librte_eal/linux/eal_memory.c b/lib/librte_eal/linux/eal_memory.c
index df0f07ee7e..03a4f2dd2d 100644
--- a/lib/librte_eal/linux/eal_memory.c
+++ b/lib/librte_eal/linux/eal_memory.c
@@ -713,8 +713,8 @@ remap_segment(struct hugepage_file *hugepages, int seg_start, int seg_end)
 	}
 	if (msl_idx == RTE_MAX_MEMSEG_LISTS) {
 		RTE_LOG(ERR, EAL, "Could not find space for memseg. Please increase %s and/or %s in configuration.\n",
-				RTE_STR(CONFIG_RTE_MAX_MEMSEG_PER_TYPE),
-				RTE_STR(CONFIG_RTE_MAX_MEM_MB_PER_TYPE));
+				RTE_STR(RTE_MAX_MEMSEG_PER_TYPE),
+				RTE_STR(RTE_MAX_MEM_MB_PER_TYPE));
 		return -1;
 	}
 
@@ -963,7 +963,7 @@ prealloc_segments(struct hugepage_file *hugepages, int n_pages)
 			}
 			if (msl_idx == RTE_MAX_MEMSEG_LISTS) {
 				RTE_LOG(ERR, EAL, "Not enough space in memseg lists, please increase %s\n",
-					RTE_STR(CONFIG_RTE_MAX_MEMSEG_LISTS));
+					RTE_STR(RTE_MAX_MEMSEG_LISTS));
 				return -1;
 			}
 
@@ -1818,7 +1818,7 @@ memseg_primary_init_32(void)
 				if (msl_idx >= RTE_MAX_MEMSEG_LISTS) {
 					RTE_LOG(ERR, EAL,
 						"No more space in memseg lists, please increase %s\n",
-						RTE_STR(CONFIG_RTE_MAX_MEMSEG_LISTS));
+						RTE_STR(RTE_MAX_MEMSEG_LISTS));
 					return -1;
 				}
 
diff --git a/lib/librte_eal/linux/eal_timer.c b/lib/librte_eal/linux/eal_timer.c
index c0a67cfd7b..7cf15cabac 100644
--- a/lib/librte_eal/linux/eal_timer.c
+++ b/lib/librte_eal/linux/eal_timer.c
@@ -163,7 +163,7 @@ rte_eal_hpet_init(int make_default)
 		RTE_LOG(ERR, EAL, "ERROR: Cannot mmap "DEV_HPET"!\n"
 				"Please enable CONFIG_HPET_MMAP in your kernel configuration "
 				"to allow HPET support.\n"
-				"To run without using HPET, set CONFIG_RTE_LIBEAL_USE_HPET=n "
+				"To run without using HPET, unset RTE_LIBEAL_USE_HPET "
 				"in your build configuration or use '--no-hpet' EAL flag.\n");
 		close(fd);
 		internal_conf->no_hpet = 1;
diff --git a/lib/librte_eal/linux/eal_vfio_mp_sync.c b/lib/librte_eal/linux/eal_vfio_mp_sync.c
index 6254696ae5..a2accfab3a 100644
--- a/lib/librte_eal/linux/eal_vfio_mp_sync.c
+++ b/lib/librte_eal/linux/eal_vfio_mp_sync.c
@@ -17,7 +17,7 @@
  * @file
  * VFIO socket for communication between primary and secondary processes.
  *
- * This file is only compiled if CONFIG_RTE_EAL_VFIO is set to "y".
+ * This file is only compiled if RTE_EAL_VFIO is set.
  */
 
 #ifdef VFIO_PRESENT
diff --git a/lib/librte_mbuf/rte_mbuf_core.h b/lib/librte_mbuf/rte_mbuf_core.h
index 8f631b84cf..065d87d28a 100644
--- a/lib/librte_mbuf/rte_mbuf_core.h
+++ b/lib/librte_mbuf/rte_mbuf_core.h
@@ -495,8 +495,7 @@ struct rte_mbuf {
 	 * It should only be accessed using the following functions:
 	 * rte_mbuf_refcnt_update(), rte_mbuf_refcnt_read(), and
 	 * rte_mbuf_refcnt_set(). The functionality of these functions (atomic,
-	 * or non-atomic) is controlled by the CONFIG_RTE_MBUF_REFCNT_ATOMIC
-	 * config option.
+	 * or non-atomic) is controlled by the RTE_MBUF_REFCNT_ATOMIC flag.
 	 */
 	uint16_t refcnt;
 	uint16_t nb_segs;         /**< Number of segments. */
diff --git a/lib/librte_rcu/rte_rcu_qsbr.h b/lib/librte_rcu/rte_rcu_qsbr.h
index 376efc630b..fa2b881bd0 100644
--- a/lib/librte_rcu/rte_rcu_qsbr.h
+++ b/lib/librte_rcu/rte_rcu_qsbr.h
@@ -84,7 +84,7 @@ struct rte_rcu_qsbr_cnt {
 	 *   changes to various APIs.
 	 */
 	uint32_t lock_cnt;
-	/**< Lock counter. Used when CONFIG_RTE_LIBRTE_RCU_DEBUG is enabled */
+	/**< Lock counter. Used when RTE_LIBRTE_RCU_DEBUG is enabled */
 } __rte_cache_aligned;
 
 #define __RTE_QSBR_CNT_THR_OFFLINE 0
@@ -383,11 +383,11 @@ rte_rcu_qsbr_thread_offline(struct rte_rcu_qsbr *v, unsigned int thread_id)
  * This API is provided to aid debugging. This should be called before
  * accessing a shared data structure.
  *
- * When CONFIG_RTE_LIBRTE_RCU_DEBUG is enabled a lock counter is incremented.
+ * When RTE_LIBRTE_RCU_DEBUG is enabled a lock counter is incremented.
  * Similarly rte_rcu_qsbr_unlock will decrement the counter. When the
  * rte_rcu_qsbr_check API will verify that this counter is 0.
  *
- * When CONFIG_RTE_LIBRTE_RCU_DEBUG is disabled, this API will do nothing.
+ * When RTE_LIBRTE_RCU_DEBUG is disabled, this API will do nothing.
  *
  * @param v
  *   QS variable
@@ -416,11 +416,11 @@ rte_rcu_qsbr_lock(__rte_unused struct rte_rcu_qsbr *v,
  * This API is provided to aid debugging. This should be called after
  * accessing a shared data structure.
  *
- * When CONFIG_RTE_LIBRTE_RCU_DEBUG is enabled, rte_rcu_qsbr_unlock will
+ * When RTE_LIBRTE_RCU_DEBUG is enabled, rte_rcu_qsbr_unlock will
  * decrement a lock counter. rte_rcu_qsbr_check API will verify that this
  * counter is 0.
  *
- * When CONFIG_RTE_LIBRTE_RCU_DEBUG is disabled, this API will do nothing.
+ * When RTE_LIBRTE_RCU_DEBUG is disabled, this API will do nothing.
  *
  * @param v
  *   QS variable